/* WINCLASS.CPP*/
#include<graphics.h>	//for graphic functions
#include<iostream.h>	//for input-output
#include<fstream.h>	//for file I/O
#include<conio.h>	//for getch, clrscr, gotoxy, kbhit
#include<string.h>	//for string functions
#include<stdio.h>	//for sscanf, sprintf, remove etc.
#include<dos.h>		//for mouse, delay, sound, time etc.
#include<stdlib.h>	//for rand , itoa, exit etc.
#include<iomanip.h>	//for setw
#include<ctype.h>	//for isprint
#include<math.h>	//for floor, modf etc.
#include"buttons.cpp"
struct theme
	{
		int bak;	//Window Background
		int tex;	//Text color
		int title;	//Window TitleBar color
		int buta;	//Active button color
		int buti;	//Inactive button color
		char name[10];	//Name of the theme
	};
theme themes[3]={ { DARKGRAY,WHITE,BLUE,YELLOW,RED,"Default" },
                  { LIGHTBLUE,WHITE,BLUE,LIGHTBLUE,LIGHTRED,"Blue" },
                  { GREEN,YELLOW,RED,DARKGRAY,RED,"Fire" }
                };		//stores window colour themes
//Constants used:
//Window sizes
#define AUTO 0		//Automatic window sizing
#define FULL 1		//Fullscreen window
//#define INPT 2		//Input textbox
#define FREE 4		//Custom size and location
//Theme names
#define GREEN 0
#define BLUE 1
#define FIRE 2
/*Class to implement the mouse interface.
  It utilizes the interrupt number 0x33 to perform the various
  mouse operations.*/
class mouse
	{
	private:
		union REGS i,o;		//from <dos.h>
	public:
		mouse()                         //constructor
		{
			initmouse();
		}
		void initmouse()                //initialises the mouse
		{
			i.x.ax=0;
			int86 ( 0x33,&i,&o );
		}
		void showmouseptr()             //display the pointer
		{
			i.x.ax=1;
			int86 ( 0x33,&i,&o );
		}
		void hidemouseptr()             //hide the pointer
		{
			i.x.ax=2;
			int86 ( 0x33,&i,&o );
		}
		void getmousepos(int &button,int &x,int &y)
		{                               //to obtain mouse coordinates
			i.x.ax=3;               //and button status
			int86 ( 0x33,&i,&o );
			button=o.x.bx;
			x=o.x.cx;
			y=o.x.dx;
		}
	};
/* win class - the GUI backbone of the program.
   This class allows you to draw a window on the screen having
   extremely close resemblence with a typical Windows98(R) screen.
   Once this class is defined, it makes programming in GUI mode
   a childs play. It contains inbuilt functions to display the
   contents in Windows98(R) manner and to input from keyboard
   or mouse via buttons.*/
mouse m;		//an object of mouse class
// win class : draw a basic window
class win
	{
	protected:
		int x1,y1,x2,y2;        //top-left coordinates of the window
		theme t;		//the colour theme of the window
	private:
		int maxx,maxy,cx,cy;    //maximum and central coordinates
		int type;		//type of window- NORM/INPT/FULL/FREE
		int w,h,tx;		//width, height and no. of text lines
		int rect[8];            //stores all four coordinates of the window
		int bigbk,titlebk,bigtxt; //background, title & text colours
		char text[15][80];	//store the body text
		char title[30];		//store title text
		int wait;		//to wait for key hit or not
		int resizeable;
		int oldsize[4];
	protected:
		void setrect(int,int,int,int,int,int,int,int); //to initialise rect[8]
		void drwsqr(int,int,int,int,int=0); //draws a square
		void drwrct(int,int,int,int,int);   //draws a rectangle
	public:
		win();			//initialise the window settings
		void stl(char*);	//set title text
		void stx(int,char*);	//set body text (according to line no.)
		void atx(int,char*);	//append to a text line
		void shw(int,int);	//set height and width in characters
		void sxy(int,int,int,int); //set height and width in pixels
		void trans();		//calculate coordinates
		void st(int);		//set window type- NORM/INPT/FULL/FREE
		void settheme(int=BLUE); //set colour scheme for window
		void getclose(int &xx2,int &yy1); //to obtain top-right(X) coordinates
		void draw();		//calls trans(), showbody() and draw() in order
		void showbody();	//only draws the body
		void show();		//draws the buttons and gets any input etc.
		void getcoords(int &x11,int &y11,int &x21,int &y21)
		{
			x11=x1;
			x21=x2;
			y11=y1;
			y21=y2;
		}
		void setwait(int w)
		{
			if(w)
				wait=1;
			else
				wait=0;
		}
	int gettype() {return type;}
		int getresizeable(){ return resizeable;}
		void setresizeable(int aa) { resizeable=!!aa; }
		void maximize() {
			if(type!=FULL)
				{
					oldsize[0]=x1;
					oldsize[1]=y1;
					oldsize[2]=x2;
					oldsize[3]=y2;
					st(FULL);
					trans();
					m.hidemouseptr();
					showbody();
					m.showmouseptr();
				}
		}
		void restore() {
			if(type==FULL)
				{
					m.hidemouseptr();
					drwrct(1,1,639,479,LIGHTGRAY);
					x1=oldsize[0];
					y1=oldsize[1];
					x2=oldsize[2];
					y2=oldsize[3];
					st(AUTO);
					trans();
					showbody();
					m.showmouseptr();
				}
		}
	};
win::win()
{
	maxx=getmaxx();
	maxy=getmaxy();
	cx=maxx/2;
	cy=maxy/2;
	x1=cx-200;			//default window coordinates
	y1=cy-100;
	x2=cx+200;
	y2=cy+100;
	type=AUTO;
	h=5;
	w=10;
	tx=0;
	setrect(x1,y1,x2,y1,x2,y2,x1,y2);
	settheme(BLUE);
	wait=1;
	for(int i=0;i<15;i++)
		strcpy(text[i],"");
	stl("Untitled");
	resizeable=0;
}
void win::stl(char *s)
{
	sprintf(title,"  %s",s);
}
void win::stx(int i,char *s)
{
	if(i<=15) {
			if(i-1>tx)
				tx=i-1;
			strcpy(text[i-1],s);
		}
	if(h<tx+5)
		h=tx+5;
	if(strlen(s)>w)
		{
			w=strlen(s)+6;
		}
}
void win::atx(int i,char *s)
{
	if(i<=tx+1)
		{
			strcat(text[i-1],s);
		}
}
void win::shw(int a,int b)
{
	if(b==0)	h=a;
	else if(a==0)	w=b;
	else
		{
			h=a;
			w=b;
		}
}
void win::sxy(int a,int b,int c,int d)
{
	type=FREE;
	x1=a;
	y1=b;
	h=c;
	w=d;
}
void win::trans()
{
	if(type==AUTO)
		{
			if(y2-y1<(h*13)+15)
				{
					y1=(maxy/2)-(((h*15)+15)/2);
					y2=(maxy/2)+(((h*13)+15)/2);
				}
			if(x2-x1<(w*8)+4)
				{
					x1=(maxx/2)-((w*10)+4)/2;
					x2=(maxx/2)+((w*10)+4)/2;
				}
		}
	if(type==FULL)
		{
			x1=y1=1;
			x2=maxx;
			y2=maxy;
		}
	if(type==FREE)
		{
			if(y2-y1<(h*13)+15)
				{
					y2=y1+((h*13)+15);
				}
			if(x2-x1<(w*8)+4)
				{
					x2=x1+(w*8)+4;
				}
			if(h>0&&h<=5)
				y2=y1+100;
		}
	setrect(x1,y1,x2,y1,x2,y2,x1,y2);
}
void win::st(int t)
{
	type=t;
}
void win::settheme(int a)
{
	t=themes[a];
	bigbk=themes[a].bak;
	titlebk=themes[a].title;
	bigtxt=themes[a].tex;
}
void win::getclose(int& xx2,int &yy1)
{
	xx2=x2; yy1=y1;
}
void win::draw()
{
	trans();
	m.hidemouseptr();
	showbody();
	m.showmouseptr();
	show();
}
void win::showbody()
{
	setcolor(WHITE);
	setfillstyle(1,bigbk);
	fillpoly(4,rect);
	int ttle[]={x1,y1,x2,y1,x2,y1+15,x1,y1+15};
	setfillstyle(1,titlebk);
	fillpoly(4,ttle);
	drwsqr(x1+4,y1+4,6,LIGHTGRAY);
	drwsqr(x2-13,y1+2,11,BLUE,1);
	drwsqr(x2-27,y1+2,11,BLUE,2);
	settextstyle(SMALL_FONT,HORIZ_DIR,5);
	setcolor(WHITE);
	outtextxy(x1,y1,title);
	setcolor(bigtxt);
	settextstyle(SMALL_FONT,HORIZ_DIR,6);
	for(int ii=0;ii<=tx;ii++)
		outtextxy(x1+10,y1+15+(13*ii),text[ii]);
}
void win::show()
{
	int but=0,x,y;
	if(graphresult()!=grOk)		//if graphics are not initialised
		{
			for(int i=0;i<tx;i++)
				cout<<text[i];     //just display the text
			return;
		}
	if(wait)
		{
			m.showmouseptr();
			while(1)
				{
					m.getmousepos(but,x,y);
					if((but&1)==1)
						{
							while((but&1)==1)
								m.getmousepos(but,x,y);
							if(x>x2-26&&x<x2-13&&y>y1&&y<y1+13&&resizeable)
								{
									if(type!=FULL)
										maximize();
									else
										restore();
								}
							else
								{
									m.hidemouseptr();
									wait=0;
									break;
								}
						}
					if(kbhit())
						break;
				}
		}
}
void win::setrect(int a,int aa,int b,int bb,int c,int cc,int d,int dd)
{
	rect[0]=a; rect[1]=aa;
	rect[2]=b; rect[3]=bb;
	rect[4]=c; rect[5]=cc;
	rect[6]=d; rect[7]=dd;
}
void win::drwsqr(int x,int y,int sz,int col,int typ)
{
	int coord[8]={x,y,x+sz,y,x+sz,y+sz,x,y+sz};
	setfillstyle(1,col);
	fillpoly(4,coord);
	if(typ==1)
		{
			line(x,y,x+sz,y+sz);
			line(x,y+sz,x+sz,y);
		}
	if(typ==2)
		{
			line(x+2,y+sz-2,x+sz-2,y+sz-2);
		}
}
void win::drwrct(int x,int y,int sz1,int sz2,int col)
{
	int coord[8]={x,y,x+sz1,y,x+sz1,y+sz2,x,y+sz2};
	setfillstyle(1,col);
	fillpoly(4,coord);
}
////////////////END OF win CLASS////////////////////////////
////////////////////////////////////////////////////////////

//An Input Window class derived from the basic win class
class win_input: public win
	{
		char ip[30];		//the title for input window in INPT type
		char inpt[50];
	public:
		win_input() :win()
		{
			strcpy(ip,"");
		}
		void sip(char *s)	//set input window title
		{
			strcpy(ip,s);
		}
		void st(int t)
		{
			win::st(t);
		}
		void trans()
		{
			win::trans();
			stl("  INPUT...");
			stx(6,"Please input...");
			stx(7,"Hit ENTER to accept or ESC to cancel.");
			setwait(0);
		}
		void show();
		void draw()
		{
			trans();
			showbody();
			show();
		}
		char* getinput()
		{
			return inpt;
		}
	};
void win_input::show()
{
	m.hidemouseptr();
	button ok;
	int x1,y1;
	int x2,y2;
	getcoords(x1,y1,x2,y2);
	ok.setxy((x2-x1)/2+x1,y1+150);
	ok.settext(" OK ");
	ok.setstate(1);
	ok.draw();
	outtextxy(x1+10,y1+35,"Please Enter");
	outtextxy(x1+110,y1+35,ip);
	drwrct(x1+10,y1+60,x2-x1-20,20,BLACK);
	char buf[80];
	buf[0]='\0';
	char ch,cha[2];
	int x=x1+10,i=0;
	setcolor(WHITE);
	line(x,y1+80,x+10,y1+80);
	do {
			ch=getch();
			cha[0]=ch;
			cha[1]='\0';
			if(ch==8&&x>=x1+10&&i>0)
				{
					setcolor(BLACK);
					drwrct(x-10,y1+60,10,20,BLACK);
					setcolor(WHITE);
					line(x-20,y1+80,x-10,y1+80);
					x-=10;
					buf[i--]='\0';
				}
			else
				if(isprint(ch))
					{
						setcolor(WHITE);
						outtextxy(x,y1+60,cha);
						x+=10;
						line(x,y1+80,x+10,y1+80);
						buf[i]=ch;
						buf[++i]='\0';
					}
		} while(ch!=13&&ch!=27&&i<76);
	//		if(ch==27) choice=-1;
	strcpy(inpt,buf);
}

//A Window with buttons, again derived from win class
class win_buttons:public win
	{
	protected:
		int buts;
		button *b;
	public:
		int choice;
		win_buttons();
		void sb(int);		//set the no. of buttons
		void sbt(int,char*);	//set buton text (according to button no.)
		void settheme(int);
		void show();
		void trans();
		void draw()
		{
			trans();
			showbody();
			show();
		}
	};
win_buttons::win_buttons()
{
	buts=0;
	choice=1;
	b=NULL;
	setwait(0);
	settheme(BLUE);
}
void win_buttons::settheme(int th)
{
	win::settheme(th);
	for(int i=0;i<buts;i++)
		b[i].setcols(themes[th].buti,themes[th].buta);
}
void win_buttons::trans()
{
	win::trans();
	for(int i=0;i<buts;i++)
		b[i].setcols(t.buti,t.buta);
	int cx=getmaxx()/2;
	if(buts>=3&&x2-x1<450)  {
			x1=cx-250;
			x2=cx+250;
		}
	if(buts)
		{
			int step=(x2-x1)/4;
			int m=60;
			int ctr=1;
			if(buts<=3)
				{m=30;
					for(int i=0;i<=buts;i++)
						{
							b[i].setxy(x1+(step*(i+1)),y2-m);
							if(choice==ctr)
								b[i].setstate(1);
							else
								b[i].setstate(0);
							b[i].draw();
						}
				} else
				if(buts>=4)
					for(int i=0;i<2;i++)
						{
							for(int j=1;j<=3&&ctr<=buts;j++)
								{
									b[ctr-1].setxy(x1+(step*j),y2-m);
									if(choice==ctr)
										b[ctr-1].setstate(1);
									else
										b[ctr-1].setstate(0);
									ctr++;
								}
							m=30;
						}
		}
	setrect(x1,y1,x2,y1,x2,y2,x1,y2);
}
void win_buttons::show()
{
	if(buts)
		setwait(0);
	win::show();
	char hit;
	int but,x,y,flag=0;
	do {
			for(int i=0;i<buts;i++)
				{
					if(choice==i+1)
						b[i].setstate(1);
					else
						b[i].setstate(0);
					b[i].draw();
				}
			int clk=0,key=0, oldchoice=choice;
			do
				{
					m.showmouseptr();
					m.getmousepos(but,x,y);
					if((but&1)==1)
						{
							m.hidemouseptr();
							if(x>x2-13&&x<x2&&y>y1&&y<y1+13)
								{
									choice=0;
									hit=27;
									clk=1;
									flag=1;
								}
							if(getresizeable())
								if(x>x2-27&&x<x2-13&&y>y1&&y<y1+13)
									{
										if(gettype()==FULL)
											restore();
										else
											maximize();
										trans();
										for(int i=0;i<buts;i++)
											{
												if(choice==i+1)
													b[i].setstate(1);
												else
													b[i].setstate(0);
												b[i].draw();
											}
									}
							for(int p=0;p<buts;p++)
								{
									if(b[p].mouseover(x,y))
										{
											oldchoice=choice;
											choice=p+1;
											hit=13;
											clk=1;
											break;
										}
								}
						}
					if(kbhit())
						{
							key=1;
						}
				}while(!clk&&!key);
			if(key)
				{
					hit=getch();
					if(hit==13) break;
					if(hit==27)
					{  choice=0; break; }
					if(hit==77&&choice<buts)
					{  choice++; hit=0; }
					if(hit==77&&choice==buts)
						choice=1;
					if(hit==72&&choice>3)
						choice-=3;
					if(hit==80&&choice<=3)
						if(buts>3)
							choice+=3;
					if(hit==75&&choice>1)
					{  choice--; hit=0; }
					if(hit==75&&choice==1)
						choice=buts;
					if(hit==77&&choice==buts)
						choice=1;
					sound(100);
					nosound();
				}
			if(hit==13)
				{
					if(oldchoice!=choice)
						{
							b[oldchoice-1].setstate(0);
							b[oldchoice-1].draw();
						}
					sound(500);
					b[choice-1].setstate(-1);
					b[choice-1].draw();
					m.showmouseptr();
					while((but&1)==1)
						{	m.getmousepos(but,x,y);
							flag=1;
						}
					m.hidemouseptr();
					b[choice-1].setstate(1);
					b[choice-1].draw();
					nosound();
				}
		} while(flag==0);
}
void win_buttons::sb(int n)
{
	buts=n;
	if(b==NULL)
		b=new button[n];
	else
		{
			delete b;
			b=new button[n];
		}
	setwait(0);
}
void win_buttons::sbt(int i,char *s)
{
	if(i<=buts)
		b[i-1].settext(s);
}

// A Window with a parallel process running, derived from win_buttons
class win_func : public win_buttons
	{
		int func;
		int init;
	public:
		win_func()
		{
			func=0;
			init=0;
		}
		void show();
		void setfunc(int a)
		{
			if(a) func=1;
			else func=0;
		}
		void draw()
		{
			init=0;
			trans();
			showbody();
			show();
		}
		virtual void winfunc();
		virtual void initfunc();
	};
void win_func::show()
{
	if(buts)
		setwait(0);
	win::show();
	char hit;
	int but,x,y,flag=0;
	do {
			for(int i=0;i<buts;i++)
				{
					if(choice==i+1)
						b[i].setstate(1);
					else
						b[i].setstate(0);
					b[i].draw();
				}
			int clk=0,key=0, oldchoice=choice;
			do
				{
					m.showmouseptr();
					m.getmousepos(but,x,y);
					if((but&1)==1)
						{
							m.hidemouseptr();
							if(x>x2-13&&x<x2&&y>y1&&y<y1+13)
								{
									choice=0;
									hit=27;
									clk=1;
									flag=1;
									//break;
								}
							for(int p=0;p<buts;p++)
								{
									if(b[p].mouseover(x,y))
										{
											oldchoice=choice;
											choice=p+1;
											hit=13;
											clk=1;
											break;
										}
								}
						}
					if(kbhit())
						{
							key=1;
						}
					if(func)
						{
							if(!init)
								{
									initfunc();
									init=1;
								}
							winfunc();
						}
				}while(!clk&&!key);
			if(key)
				{
					hit=getch();
					if(hit==13) break;
					if(hit==27)
					{  choice=0; break; }
					if(hit==77&&choice<buts)
					{  choice++; hit=0; }
					if(hit==77&&choice==buts)
						choice=1;
					if(hit==72&&choice>3)
						choice-=3;
					if(hit==80&&choice<=3)
						if(buts>3)
							choice+=3;
					if(hit==75&&choice>1)
					{  choice--; hit=0; }
					if(hit==75&&choice==1)
						choice=buts;
					if(hit==77&&choice==buts)
						choice=1;
					sound(100);
					nosound();
				}
			if(hit==13)
				{
					if(oldchoice!=choice)
						{
							b[oldchoice-1].setstate(0);
							b[oldchoice-1].draw();
							//	b[choice-1].setstate(1);
							//	b[choice-1].draw();
						}
					sound(500);
					b[choice-1].setstate(-1);
					b[choice-1].draw();
					m.showmouseptr();
					while((but&1)==1)
						{	m.getmousepos(but,x,y);
							flag=1;
						}
					m.hidemouseptr();
					b[choice-1].setstate(1);
					b[choice-1].draw();
					nosound();
				}
		} while(flag==0);
}
